package org.nongnu.savannah.jcurzez.test;

import java.text.NumberFormat;

import org.nongnu.savannah.jcurzez.BackgroundColor;
import org.nongnu.savannah.jcurzez.ForegroundColor;
import org.nongnu.savannah.jcurzez.Screen;



// Each message should show up in a single place -- letters should not be spread about.
// The messages should be (roughly) along the diagonal.  One message may entirely overwrite another.
// Two messages should never overlap, appear in the same row, or begin in the same column in different rows.

public class ThreadedCursorJumper {
	

    static long numCursorJumps = 0;
    static Object lock = new Object();
	static boolean done = false;
    
	public static void main(String[] args) {
		final Screen s = Screen.getScreen();
		
		s.getRectangle().getFillingPen().setBackgroundColor(BackgroundColor.MAGENTA);
		s.clear();
		s.refresh();
		
		
		Thread cursorJumper = new Thread(){
			public void run(){
				while (!done) {
					//int x = Math.round((float) (Math.random() * 68.0));
					int y = Math.round((float) (Math.random() * 22.0)); //don't go to 23 to avoid screen scrolling.
					int x = y*3;
					
					s.setCursorXY(x, y);
					
					synchronized (lock) {
						numCursorJumps++;
					}
				}
			}
		};
		cursorJumper.start();
		
		
		for (int i = 0; i < 15; i++){
			//s.setCursorXY((i/5)*20, (i%5) * 3);
			s.printString("Message# " + (i<10?"0":"") + i);
			s.refresh();
			try {
				Thread.sleep((int) (500));
			} catch (InterruptedException e) {
			}
		}
		
		done = true;
		try { cursorJumper.join(); } catch (InterruptedException ie){}
		
		s.setCursorXY(0, 22);
		synchronized(lock){
			s.printString(NumberFormat.getIntegerInstance().format(numCursorJumps));
		}
		s.refresh();
	}

}
