package org.nongnu.savannah.jcurzez.test;

import java.text.NumberFormat;

import org.nongnu.savannah.jcurzez.BackgroundColor;
import org.nongnu.savannah.jcurzez.ForegroundColor;
import org.nongnu.savannah.jcurzez.Screen;



//Each message should show up in a single color -- no message should have 
//letters of different color -- despite the color changer thread constantly
//updating the drawing pen.

public class ThreadedColorChanger {

	
	private static final BackgroundColor[] BG =
    { BackgroundColor.BLACK, BackgroundColor.RED, BackgroundColor.GREEN,
      BackgroundColor.YELLOW, BackgroundColor.BLUE, BackgroundColor.MAGENTA,
      BackgroundColor.CYAN, BackgroundColor.WHITE };

    private static final ForegroundColor[] FG =
    { ForegroundColor.BLACK, ForegroundColor.RED, ForegroundColor.GREEN,
      ForegroundColor.YELLOW, ForegroundColor.BLUE, ForegroundColor.MAGENTA,
      ForegroundColor.CYAN, ForegroundColor.WHITE };
	
    static long numColorChanges = 0;
    static Object lock = new Object();
    
	public static void main(String[] args) {
		final Screen s = Screen.getScreen();
		
		Thread colorChanger = new Thread(){
			public void run(){
				while (true) {
					int bg = Math.round((float) (Math.random() * 7.0));
					int fg = Math.round((float) (Math.random() * 7.0));
					if (fg == bg)
						fg = (fg + 1) % 8;
					s.getRectangle().getDrawingPen().setBackgroundColor(BG[bg]);
					s.getRectangle().getDrawingPen().setForegroundColor(FG[fg]);
					synchronized(lock){numColorChanges++;}
				}
			}
		};
		colorChanger.setDaemon(true);
		colorChanger.start();
		
		for (int i = 0; i < 15; i++){
			s.getCursor().setXY((i/5)*20, (i%5) * 3);
			s.printString("Message # " + i);
			s.refresh();
			try {
				Thread.sleep((int) (500));
			} catch (InterruptedException e) {
			}
		}
		
		s.getCursor().setXY(0, 22);
		synchronized(lock){
			s.printString(NumberFormat.getIntegerInstance().format(numColorChanges)); // new Long(numColorChanges).toString());
		}
		s.refresh();
		
	}

}
